import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface PipesPipeConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#description PipesPipe#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#desired_state PipesPipe#desired_state}
    */
    readonly desiredState?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#enrichment PipesPipe#enrichment}
    */
    readonly enrichment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#id PipesPipe#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#name PipesPipe#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#name_prefix PipesPipe#name_prefix}
    */
    readonly namePrefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#role_arn PipesPipe#role_arn}
    */
    readonly roleArn: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#source PipesPipe#source}
    */
    readonly source: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#tags PipesPipe#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#tags_all PipesPipe#tags_all}
    */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#target PipesPipe#target}
    */
    readonly target: string;
    /**
    * source_parameters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#source_parameters PipesPipe#source_parameters}
    */
    readonly sourceParameters: PipesPipeSourceParameters;
    /**
    * target_parameters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#target_parameters PipesPipe#target_parameters}
    */
    readonly targetParameters: PipesPipeTargetParameters;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#timeouts PipesPipe#timeouts}
    */
    readonly timeouts?: PipesPipeTimeouts;
}
export interface PipesPipeSourceParametersFilterCriteriaFilter {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#pattern PipesPipe#pattern}
    */
    readonly pattern: string;
}
export declare function pipesPipeSourceParametersFilterCriteriaFilterToTerraform(struct?: PipesPipeSourceParametersFilterCriteriaFilter | cdktf.IResolvable): any;
export declare class PipesPipeSourceParametersFilterCriteriaFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PipesPipeSourceParametersFilterCriteriaFilter | cdktf.IResolvable | undefined;
    set internalValue(value: PipesPipeSourceParametersFilterCriteriaFilter | cdktf.IResolvable | undefined);
    private _pattern?;
    get pattern(): string;
    set pattern(value: string);
    get patternInput(): string | undefined;
}
export declare class PipesPipeSourceParametersFilterCriteriaFilterList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PipesPipeSourceParametersFilterCriteriaFilter[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PipesPipeSourceParametersFilterCriteriaFilterOutputReference;
}
export interface PipesPipeSourceParametersFilterCriteria {
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#filter PipesPipe#filter}
    */
    readonly filter?: PipesPipeSourceParametersFilterCriteriaFilter[] | cdktf.IResolvable;
}
export declare function pipesPipeSourceParametersFilterCriteriaToTerraform(struct?: PipesPipeSourceParametersFilterCriteriaOutputReference | PipesPipeSourceParametersFilterCriteria): any;
export declare class PipesPipeSourceParametersFilterCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipesPipeSourceParametersFilterCriteria | undefined;
    set internalValue(value: PipesPipeSourceParametersFilterCriteria | undefined);
    private _filter;
    get filter(): PipesPipeSourceParametersFilterCriteriaFilterList;
    putFilter(value: PipesPipeSourceParametersFilterCriteriaFilter[] | cdktf.IResolvable): void;
    resetFilter(): void;
    get filterInput(): cdktf.IResolvable | PipesPipeSourceParametersFilterCriteriaFilter[] | undefined;
}
export interface PipesPipeSourceParameters {
    /**
    * filter_criteria block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#filter_criteria PipesPipe#filter_criteria}
    */
    readonly filterCriteria?: PipesPipeSourceParametersFilterCriteria;
}
export declare function pipesPipeSourceParametersToTerraform(struct?: PipesPipeSourceParametersOutputReference | PipesPipeSourceParameters): any;
export declare class PipesPipeSourceParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipesPipeSourceParameters | undefined;
    set internalValue(value: PipesPipeSourceParameters | undefined);
    private _filterCriteria;
    get filterCriteria(): PipesPipeSourceParametersFilterCriteriaOutputReference;
    putFilterCriteria(value: PipesPipeSourceParametersFilterCriteria): void;
    resetFilterCriteria(): void;
    get filterCriteriaInput(): PipesPipeSourceParametersFilterCriteria | undefined;
}
export interface PipesPipeTargetParameters {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#input_template PipesPipe#input_template}
    */
    readonly inputTemplate?: string;
}
export declare function pipesPipeTargetParametersToTerraform(struct?: PipesPipeTargetParametersOutputReference | PipesPipeTargetParameters): any;
export declare class PipesPipeTargetParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipesPipeTargetParameters | undefined;
    set internalValue(value: PipesPipeTargetParameters | undefined);
    private _inputTemplate?;
    get inputTemplate(): string;
    set inputTemplate(value: string);
    resetInputTemplate(): void;
    get inputTemplateInput(): string | undefined;
}
export interface PipesPipeTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#create PipesPipe#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#delete PipesPipe#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe#update PipesPipe#update}
    */
    readonly update?: string;
}
export declare function pipesPipeTimeoutsToTerraform(struct?: PipesPipeTimeouts | cdktf.IResolvable): any;
export declare class PipesPipeTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipesPipeTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: PipesPipeTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe aws_pipes_pipe}
*/
export declare class PipesPipe extends cdktf.TerraformResource {
    static readonly tfResourceType = "aws_pipes_pipe";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/pipes_pipe aws_pipes_pipe} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options PipesPipeConfig
    */
    constructor(scope: Construct, id: string, config: PipesPipeConfig);
    get arn(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _desiredState?;
    get desiredState(): string;
    set desiredState(value: string);
    resetDesiredState(): void;
    get desiredStateInput(): string | undefined;
    private _enrichment?;
    get enrichment(): string;
    set enrichment(value: string);
    resetEnrichment(): void;
    get enrichmentInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _namePrefix?;
    get namePrefix(): string;
    set namePrefix(value: string);
    resetNamePrefix(): void;
    get namePrefixInput(): string | undefined;
    private _roleArn?;
    get roleArn(): string;
    set roleArn(value: string);
    get roleArnInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    get sourceInput(): string | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    get tagsAll(): {
        [key: string]: string;
    };
    set tagsAll(value: {
        [key: string]: string;
    });
    resetTagsAll(): void;
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    get targetInput(): string | undefined;
    private _sourceParameters;
    get sourceParameters(): PipesPipeSourceParametersOutputReference;
    putSourceParameters(value: PipesPipeSourceParameters): void;
    get sourceParametersInput(): PipesPipeSourceParameters | undefined;
    private _targetParameters;
    get targetParameters(): PipesPipeTargetParametersOutputReference;
    putTargetParameters(value: PipesPipeTargetParameters): void;
    get targetParametersInput(): PipesPipeTargetParameters | undefined;
    private _timeouts;
    get timeouts(): PipesPipeTimeoutsOutputReference;
    putTimeouts(value: PipesPipeTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | PipesPipeTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
