import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface Resourceexplorer2IndexConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index#tags Resourceexplorer2Index#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index#type Resourceexplorer2Index#type}
    */
    readonly type: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index#timeouts Resourceexplorer2Index#timeouts}
    */
    readonly timeouts?: Resourceexplorer2IndexTimeouts;
}
export interface Resourceexplorer2IndexTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index#create Resourceexplorer2Index#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index#delete Resourceexplorer2Index#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index#update Resourceexplorer2Index#update}
    */
    readonly update?: string;
}
export declare function resourceexplorer2IndexTimeoutsToTerraform(struct?: Resourceexplorer2IndexTimeouts | cdktf.IResolvable): any;
export declare class Resourceexplorer2IndexTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Resourceexplorer2IndexTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: Resourceexplorer2IndexTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index aws_resourceexplorer2_index}
*/
export declare class Resourceexplorer2Index extends cdktf.TerraformResource {
    static readonly tfResourceType = "aws_resourceexplorer2_index";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/aws/4.65.0/docs/resources/resourceexplorer2_index aws_resourceexplorer2_index} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options Resourceexplorer2IndexConfig
    */
    constructor(scope: Construct, id: string, config: Resourceexplorer2IndexConfig);
    get arn(): string;
    get id(): string;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll;
    get tagsAll(): cdktf.StringMap;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _timeouts;
    get timeouts(): Resourceexplorer2IndexTimeoutsOutputReference;
    putTimeouts(value: Resourceexplorer2IndexTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | Resourceexplorer2IndexTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
